package ssc;

import java.awt.*;

public class Bullet{
    
    private Unit owner;
    private GameObject target;

    private int y0;

    private int getState() {return y0; };

    // 
    private double x;
    private double y;

    /**
    *  x 
    */
    public int getX() {return (int)x;};

    /**
    *  y 
    */
    public int getY() {return (int)y;};

    //  
    private double directX;
    private double directY;
    
    /**
    *    
    * @param x x 
    * @param y y 
    */
    public void setDirect(double x, double y) {
        directX = x;
        directY = y;
    };

    /**
    * .   ,   
    * @param o ,  
    */
    public Bullet(Unit o) {
        owner = o;
        target = owner.getTarget(); 
        x = o.getX();
        y = o.getY();
        y0 = 1; // , .. 
    };

    /**
    *  .   
    */
    public Bullet() {
        y0 = 0;
    };

    /**
    *       
    */
    public void move() {
        if ((x - target.getX()) * (x - target.getX()) 
          + (y - target.getY()) * (y - target.getY()) > 10) {

            double directX = target.getX() - x;
            double directY = target.getY() - y;

            double d = Math.sqrt(directX * directX + directY * directY); 

            x = x + 6 * directX/d;
            y = y + 6 * directY/d;
            
        }else{
            y0 = 0; //
            target.damage(30);
//            owner.field.btnpanel.unitUpdate(); //  
            owner.getField().bullets.remove(this);
            owner.getField().bursts.add(new Burst(target));
        };    
    };

    /**
    *  
    * @param g  
    */
    public void paint(Graphics g) {
    	Color old = g.getColor();
    	g.setColor(Color.yellow);

        double directX = target.getX() - x;
        double directY = target.getY() - y;

        double d = Math.sqrt(directX * directX + directY * directY); 
        double l = 5;
        g.drawLine((int)(x - l/d * directX), (int)(y - l/d * directY), (int)(x + l/d * directX), (int)(y + l/d * directY));
        
        g.setColor(old);
    };
    
    /**
    * ,   
    */
    public boolean isAlive() {
        return (y0 == 1);
    };

};
