package ssc;

import java.awt.*;
import java.awt.event.*;

class ClientArea extends Panel {
    public Image buffer;

    public SwitchStarCraft owner;

    public ClientArea(SwitchStarCraft owner) {
        super();
        setBackground(Color.black);
        this.owner = owner;
        buffer = createImage(getSize().width, getSize().height);
        addComponentListener(new ComponentAdapter() {
            public void componentResized(ComponentEvent e) {
                if ((getSize().width >= 0) && (getSize().height >= 0))
                    buffer = createImage(getSize().width, getSize().height);
            }
        });
    }

    public void paint(Graphics g) {
        if (buffer == null) {
            buffer = createImage(getSize().width, getSize().height);
        };
        Graphics bg = buffer.getGraphics();
        buffer.flush();
        bg.clearRect(0, 0, getSize().width, getSize().height);
        owner.paintClient(bg);
        g.drawImage(buffer, 0, 0, null);
        bg.dispose();
    }

    public final void update(Graphics g) {
        paint(g);
    }

}
