package ssc;

import java.awt.*;
import java.awt.geom.*;

/**
 *  1 - ,        
 */
class Scanner1 extends Scanner {
    public Scanner1(Unit o) {
        A3 = new AutomatScanner();
        A3.setName("Scanner #1 (" + o.getName() + ")");
        switchScanner(false); // 
        setOwner(o);
        logLaunch();
    };

    public void run() {
        Unit o = getOwner();
        if (Math.abs(o.getX() - o.getDestinationX()) +
                Math.abs(o.getY() - o.getDestinationY()) <= 10) {
            o.getA0().A(6); //  "1.!"
        }
    };
}

/**
 *  2 - ,   -    ?
 */
class Scanner2 extends Scanner {
    public Scanner2(Unit o) {
        A3 = new AutomatScanner();
        A3.setName("Scanner #2 (" + o.getName() + ")");
        switchScanner(false); // 
        setOwner(o);
        logLaunch();
    };

    public void run() {
        Unit o = getOwner();
        double r;
        double xx;
        double yy;
        GameObject AnotherUnit;
        for (int i = 0; i < o.getField().units.size(); i++) {
            AnotherUnit = (GameObject) o.getField().units.elementAt(i);
            if ((AnotherUnit != null) && (getOwner() != AnotherUnit) && (o.getTeam() != AnotherUnit.getTeam())) {
                xx = AnotherUnit.getX();
                yy = AnotherUnit.getY();
                r = Math.sqrt((o.getX() - xx) * (o.getX() - xx) + (o.getY() - yy) * (o.getY() - yy));
                if (r <= o.getSightRange()) {
                    o.setTarget(AnotherUnit);
                    o.getA0().A(7); //  "2. !"
                    return;
                }
            }
        }
    }
}

/**
 *  3 - ,     ?
 */
class Scanner3 extends Scanner {
    public Scanner3(Unit o) {
        A3 = new AutomatScanner();
        A3.setName("Scanner #3 (" + o.getName() + ")");
        switchScanner(false); // 
        setOwner(o);
        logLaunch();
    };

    public void run() {
        Unit o = getOwner();
        if (!o.getTarget().isAlive()) o.getA0().A(8); //  "3. !"
    };
}

/**
 *  4 - ,        ?
 */
class Scanner4 extends Scanner {
    public Scanner4(Unit o) {
        A3 = new AutomatScanner();
        A3.setName("Scanner #4 (" + o.getName() + ")");
        switchScanner(false); // 
        setOwner(o);
        logLaunch();
    };

    public void run() {
        Unit o = getOwner();
        double xx = o.getTarget().getX();
        double yy = o.getTarget().getY();
        double r = Math.sqrt((o.getX() - xx) * (o.getX() - xx) + (o.getY() - yy) * (o.getY() - yy));
        if (r <= o.getAttackRange()) {
            o.getA0().A(9); //  "4.   !"
        } else {
            o.getA0().A(10); //  "4.    ,  !"
        }
    };
}

/**
 *  5 - ,   -    ?
 */
class Scanner5 extends Scanner {
    public Scanner5(Unit o) {
        A3 = new AutomatScanner();
        A3.setName("Scanner #5 (" + o.getName() + ")");
        switchScanner(false); // 
        setOwner(o);
        logLaunch();
    };

    public void run() {
        Unit o = getOwner();
        double r;
        double xx;
        double yy;
        for (int i = 0; i < o.getField().units.size(); i++) {
            GameObject unit = (GameObject) o.getField().units.elementAt(i);
            if ((unit.isAlive()) && (o != unit) && (o.getTeam() != unit.getTeam())) {
                xx = unit.getX();
                yy = unit.getY();
                r = Math.sqrt((o.getX() - xx) * (o.getX() - xx) + (o.getY() - yy) * (o.getY() - yy));
                if (r <= o.getAttackRange()) {
                    o.setTarget(unit);
                    o.getA0().A(11); //  "2.    !"
                    return;
                }
            }
        }
    };
}

/**
 *  6 - ,    ?
 */
class Scanner6 extends Scanner {
    public Scanner6(Unit o) {
        A3 = new AutomatScanner();
        A3.setName("Scanner #6 (" + o.getName() + ")");
        switchScanner(false); // 
        setOwner(o);
        logLaunch();
    };

    public void run() {
        Unit o = getOwner();
        if (o.getHealth() <= 0) {
            o.setAlive(false);
            o.getA0().A(12);
            return;
        }
    };
}

/**
 * This class implements the logic of the flying unit
 */
public class Unit extends GameObject {

    /**
     * This class implements the logic of the automat "Unit"
     */
    class AutomatUnit extends Automat {

        private Unit owner;

        /**
         * Returns an owner of this automat
         */
        public Unit getOwner() {
            return owner;
        };

        public AutomatUnit(Unit o) {
            setLogged(true);
            setStatesCount(7);
            setStateName(0, "Stop");
            setStateName(1, "Movement to the destination");
            setStateName(2, "Hold position (without attack)");
            setStateName(3, "Hold position (with attack)");
            setStateName(4, "Attack");
            setStateName(5, "Pursuit of target");
            setStateName(6, "Dead");
            owner = o;
            setName(o.getName());
            setState(0);
            setType("A0");
            logLaunch(getState());
        };

        /**
         * Transfer function of automat "Unit"
         */
        public void A(int e) {
            int y0 = getState();
            int yold = y0;
            switch (y0) {
                case 0:
                    if (e == 1) {
                        y0 = 1;
                    }
                    if (e == 2) {
                        y0 = 5;
                    }
                    if (e == 3) {
                        y0 = 2;
                    }
                    if (e == 4) {
                        y0 = 0;
                    }
                    if (e == 7) {
                        y0 = 5;
                    }
                    if (e == 12) {
                        y0 = 6;
                    }
                    break;

                case 1:
                    if (e == 1) {
                        y0 = 1;
                    }
                    if (e == 2) {
                        y0 = 5;
                    }
                    if (e == 3) {
                        y0 = 2;
                    }
                    if (e == 4) {
                        y0 = 0;
                    }
                    if (e == 6) {
                        y0 = 0;
                    }
                    if (e == 12) {
                        y0 = 6;
                    }
                    break;

                case 2:
                    if (e == 1) {
                        y0 = 1;
                    }
                    if (e == 2) {
                        y0 = 5;
                    }
                    if (e == 3) {
                        y0 = 2;
                    }
                    if (e == 4) {
                        y0 = 0;
                    }
                    if (e == 11) {
                        y0 = 3;
                    }
                    if (e == 12) {
                        y0 = 6;
                    }
                    break;

                case 3:
                    if (e == 1) {
                        y0 = 1;
                    }
                    if (e == 2) {
                        y0 = 5;
                    }
                    if (e == 3) {
                        y0 = 2;
                    }
                    if (e == 4) {
                        y0 = 0;
                    }
                    if ((e == 8) || (e == 10)) {
                        y0 = 2;
                    }
                    if (e == 12) {
                        y0 = 6;
                    }
                    break;

                case 4:
                    if (e == 1) {
                        y0 = 1;
                    }
                    if (e == 2) {
                        y0 = 5;
                    }
                    if (e == 3) {
                        y0 = 2;
                    }
                    if (e == 4) {
                        y0 = 0;
                    }
                    if (e == 8) {
                        y0 = 0;
                    }
                    if (e == 10) {
                        y0 = 5;
                    }
                    if (e == 12) {
                        y0 = 6;
                    }
                    break;

                case 5:
                    if (e == 1) {
                        y0 = 1;
                    }
                    if (e == 2) {
                        y0 = 5;
                    }
                    if (e == 3) {
                        y0 = 2;
                    }
                    if (e == 4) {
                        y0 = 0;
                    }
                    if (e == 9) {
                        y0 = 4;
                    }
                    if (e == 8) {
                        y0 = 0;
                    }
                    if (e == 12) {
                        y0 = 6;
                    }
                    break;
                case 6:
                    break;

                default:
                    break;
            }
            ;

            if (y0 != yold) {
                // Swithing on/off  scanners in accordance to new state y0.
                switch (y0) {
                    case 0:
                        z0();
                        break;
                    case 1:
                        z1();
                        break;
                    case 2:
                        z2();
                        break;
                    case 3:
                        z3();
                        break;
                    case 4:
                        z4();
                        break;
                    case 5:
                        z5();
                        break;
                    case 6:
                        z6();
                        break;
                }
                logTrans(y0, yold, e);
            }
            setState(y0);
        };

        private void z0() {
            setCurMode(MODE_STOP);
            scanner1.switchScanner(false);
            scanner2.switchScanner(true);
            scanner3.switchScanner(false);
            scanner4.switchScanner(false);
            scanner5.switchScanner(false);
            scanner6.switchScanner(true);
            cannon.nofire();
            logZ(0, "Switch scanners in accordance with state 0 (\"Stop\")");
        };

        private void z1() {
            setCurMode(MODE_MOVE);
            scanner1.switchScanner(true);
            scanner2.switchScanner(false);
            scanner3.switchScanner(false);
            scanner4.switchScanner(false);
            scanner5.switchScanner(false);
            scanner6.switchScanner(true);
            cannon.nofire();
            logZ(1, "Switch scanners in accordance with state 1 (\"Moving to the destination\") ");
        };

        private void z2() {
            setCurMode(MODE_HOLD);
            scanner1.switchScanner(false);
            scanner2.switchScanner(false);
            scanner3.switchScanner(false);
            scanner4.switchScanner(false);
            scanner5.switchScanner(true);
            scanner6.switchScanner(true);
            cannon.nofire();
            logZ(2, "Switch scanners in accordance with state 2 (\"Hold position without attack\")");
        };

        private void z3() {
            setCurMode(MODE_HOLD);
            scanner1.switchScanner(false);
            scanner2.switchScanner(false);
            scanner3.switchScanner(true);
            scanner4.switchScanner(true);
            scanner5.switchScanner(false);
            scanner6.switchScanner(true);
            cannon.fire();
            logZ(3, "Switch scanners in accordance with state 3 (\"Hold position with attack\")");
        };

        private void z4() {
            setCurMode(MODE_ATTACK);
            scanner1.switchScanner(false);
            scanner2.switchScanner(false);
            scanner3.switchScanner(true);
            scanner4.switchScanner(true);
            scanner5.switchScanner(false);
            scanner6.switchScanner(true);
            cannon.fire();
            logZ(4, "Switch scanners in accordance with state 4 (\"Attack\")");
        };

        private void z5() {
            setCurMode(MODE_ATTACK);
            scanner1.switchScanner(false);
            scanner2.switchScanner(false);
            scanner3.switchScanner(true);
            scanner4.switchScanner(true);
            scanner5.switchScanner(false);
            scanner6.switchScanner(true);
            cannon.nofire();
            logZ(5, "Switch scanners in accordance with state 5 (\"Pursuit of targer\")");
        };

        private void z6() {
            setCurMode(NO_MODE);
            scanner1.switchScanner(false);
            scanner2.switchScanner(false);
            scanner3.switchScanner(false);
            scanner4.switchScanner(false);
            scanner5.switchScanner(false);
            scanner6.switchScanner(false);
            cannon.nofire();
            logZ(6, "Switch scanners in accordance with state 6 (\"Dead\")");
        };

    };

    /***
     * Objects target
     */
    private GameObject target;

    /**
     * Returns object's target
     */
    protected GameObject getTarget() {
        return target;
    };

    /**
     * Sets the new target
     * @param target object's targer
     */
    protected void setTarget(GameObject target) {
        this.target = target;
    };

    private Scanner1 scanner1;
    private Scanner2 scanner2;
    private Scanner3 scanner3;
    private Scanner4 scanner4;
    private Scanner5 scanner5;
    private Scanner6 scanner6;

    private Cannon cannon;

    /**
     * Automat of the current unit
     */
    private AutomatUnit A0;

    /**
     * Returns the automat of this unit
     */
    public AutomatUnit getA0() {
        return A0;
    };

    /**
     * Gives an order "Move"
     */
    public void orderMove() {
        A0.A(1);
    };

    /**
     * Gives an order "Attack"
     */
    public void orderAttack() {
        A0.A(2);
    };

    /**
     * Gives an order "Hold position"
     */
    public void orderHold() {
        A0.A(3);
    };

    /**
     * Gives an order "Stop"
     */
    public void orderStop() {
        A0.A(4);
    };


    /**
     *    
     */
    public final static int NO_MODE = 0;  //  
    /**
     *    ""
     */
    public final static int MODE_STOP = 1;  // : 
    /**
     *    ""
     */
    public final static int MODE_MOVE = 2;  // : 
    /**
     *    ""
     */
    public final static int MODE_ATTACK = 3;// : 
    /**
     *    " "
     */
    public final static int MODE_HOLD = 4;  // :  

    /**
     * Creates new unit on the specified {@link BattleField}
     * @param field {@link BattleField}
     * @param name unit's name
     * @param team team number
     * @param x x-coordinate of the center
     * @param y y-coordinate of the center
     */
    public Unit(BattleField field, String name, int team, double x, double y) {
        setControlled(true);
        img = ImageMap.getImage("gif/unit" + team + ".gif");
        setTeam(team);

        setCurMode(MODE_STOP);
        setAlive(true);

        setX(x);
        setY(y);
        setDirect(1, 0);
        deselect();
        setField(field);
        setSightRange(150);
        setAttackRange(120);
        setHealth(100);
        setName(name);
        cannon = new Cannon(this);

        scanner1 = new Scanner1(this);
        scanner2 = new Scanner2(this);
        scanner3 = new Scanner3(this);
        scanner4 = new Scanner4(this);
        scanner5 = new Scanner5(this);
        scanner6 = new Scanner6(this);

        scanner1.switchScanner(false);
        scanner2.switchScanner(true);
        scanner3.switchScanner(false);
        scanner4.switchScanner(false);
        scanner5.switchScanner(false);
        scanner6.switchScanner(true);
        cannon.nofire();

        double imageWidth = 41;
        double imageHeight = 34;

        setCenter(-imageWidth * 0.5, -imageHeight * 0.5);
        setOvalRect(-imageWidth * 0.5 - 5, -10, imageWidth + 10, 30);
        setHealthRect(-imageWidth * 0.5, -imageHeight * 0.5 - 10, imageWidth, 5);

        A0 = new AutomatUnit(this);
    };

    /**
     * Sends the message "Timer:onTime()" to all scanners
     */
    public void runAllScanners() {
        scanner1.work();
        scanner2.work();
        scanner3.work();
        scanner4.work();
        scanner5.work();
        scanner6.work();
    };

    /**
     * Moves the unit
     */
    public void move() {

        double sx, sy, sz;
        double A1, B1, C1, A2, B2, C2, A3, B3, C3, D1, D2, D3;
        double xA, yA, zA;
        double xC, yC, zC;
        double delta = 4;

        int dx = 0;
        int dy = 0;

        switch (getCurMode()) {
            case MODE_ATTACK:
                dx = target.getIntX();
                dy = target.getIntY();
                break;

            case MODE_MOVE:
                dx = getDestinationX();
                dy = getDestinationY();
                break;
        }

        if ((Math.abs(getX() - dx) < delta) && (Math.abs(getY() - dy) < delta)) return;
        Vector2 v1 = new Vector2(getX() - dx, getY() - dy, 0);

        int n = 5;
        Vector2 v2 = new Vector2(getDirectX(), getDirectY(), 0);

        double xT = dx;
        double yT = dy;
        double zT = 0;

        if (v1.Angle(v2) > Math.PI * 0.1) {
            xT = (dx * 1 + getX() * n) / (n + 1);
            yT = (dy * 1 + getY() * n) / (n + 1);
            zT = 0;
        }

        sx = (getX() + xT) * 0.5;
        sy = (getY() + yT) * 0.5;

        xA = xT - getX();
        yA = yT - getY();
        zA = zT - 0;

        A1 = xA;
        B1 = yA;
        C1 = 0;
        D1 = sx * xA + sy * yA;

        A2 = getDirectX();
        B2 = getDirectY();
        C2 = 0;
        D2 = getX() * getDirectX() + getY() * getDirectY();

        Vector2 vect = new Vector2(xA, yA, 0);

        Vector2 dir = new Vector2(getDirectX(), getDirectY(), 0);
        Vector2 ortv = new Vector2();
        ortv.Ort(vect, dir);

        A3 = ortv.x;
        B3 = ortv.y;
        C3 = ortv.z;
        D3 = getX() * ortv.x + getY() * ortv.y + 0 * ortv.z;

        if ((ortv.x == 0) && (ortv.y == 0) && (ortv.z == 0)) {
            double l = getDirectX() * getDirectX() + getDirectY() * getDirectY() + 0 * 0;
            l = Math.sqrt(l);
            setDirectX(getDirectX() / l);
            setDirectY(getDirectY() / l);

            //     
            double distDo = (dx - getX()) * (dx - getX()) + (dy - getY()) * (dy - getY());
            setX(getX() + getDirectX() * 2);
            setY(getY() + getDirectY() * 2);

            //     
            double distPosle = (dx - getX()) * (dx - getX()) + (dy - getY()) * (dy - getY());
            if (distDo < distPosle) {
                setY(getY() - 2 * Math.random());
                setX(getX() - 2 * Math.random());
            }

            return;
        }
        double dett = Vector2.det3(A1, B1, C1, A2, B2, C2, A3, B3, C3);
        double detx = Vector2.det3(D1, B1, C1, D2, B2, C2, D3, B3, C3);
        double dety = Vector2.det3(A1, D1, C1, A2, D2, C2, A3, D3, C3);
        double detz = Vector2.det3(A1, B1, D1, A2, B2, D2, A3, B3, D3);

        double x0 = detx / dett;
        double y0 = dety / dett;
        double z0 = detz / dett;

        xC = x0;
        yC = y0;
        zC = z0;

        double qradius = (x0 - getX()) * (x0 - getX()) + (y0 - getY()) * (y0 - getY()) + (z0 - 0) * (z0 - 0);

        double k = 2;
        double l = getDirectX() * getDirectX() + getDirectY() * getDirectY() + 0 * 0;

        l = Math.sqrt(l);
        setDirectX(getDirectX() / l);
        setDirectY(getDirectY() / l);

        setX(getX() + getDirectX() * k);
        setY(getY() + getDirectY() * k);

        double xAcceler = ((x0 - getX())) * k / qradius;
        double yAcceler = ((y0 - getY())) * k / qradius;

        setDirectX(getDirectX() + xAcceler);
        setDirectY(getDirectY() + yAcceler);

    };

    /**
     * Draws current object
     * @param g graphic context
     */
    public void draw(Graphics g) {
        Color old = g.getColor();

        Graphics2D g2 = (Graphics2D) g;

        g2.setColor(Color.green);

        AffineTransform aT = g2.getTransform();

        double d = Math.sqrt(getDirectX() * getDirectX() + getDirectY() * getDirectY());
        double angle = Vector2.acossin(getDirectY() / d, getDirectX() / d);

        AffineTransform rotate = AffineTransform.getRotateInstance(angle, getIntX(), getIntY());

        g2.transform(rotate);
        g2.drawImage(img, getIntX() - img.getWidth(null) / 2, getIntY() - img.getHeight(null) / 2, null);

        g2.setTransform(aT);
        g2.setColor(old);
    };

    /**
     * Checks whether specified point locates inside unit
     * @param x x-coordinate
     * @param y y-coordinate
     */
    public boolean ifin(int x, int y) {
        return ((x - getX()) * (x - getX()) + (y - getY()) * (y - getY()) < 200);
    };
}
