package ssc;

import java.awt.*;
import java.awt.image.*;

/**
 * This class supports operations with landscape map
 * @author Gavrilov M.
 * @version 0.1 beta 
 */

public class Landscape {
    protected Image texture;
    protected int oldX = Integer.MAX_VALUE;
    protected int oldY = Integer.MAX_VALUE;
    protected int oldWidth = Integer.MAX_VALUE;
    protected int oldHeight = Integer.MAX_VALUE;
    protected BufferedImage cash = null;

    /**
     * Default constructor
     */
    public Landscape() {
        texture = ImageMap.getImage("gif/landscape.gif");
    }

    public void paint(Graphics g, int x, int y, int width, int height) {
        if ((width == oldWidth) && (height == oldHeight) && (x == oldX) && (y == oldY)) {
            g.drawImage(cash, 0, 0, null);
            return;
        }
        if ((oldWidth != width) || (oldHeight != height)) {
            cash = new BufferedImage(width, height, BufferedImage.TYPE_INT_RGB);
            oldWidth = width;
            oldHeight = height;
        }
        oldX = x;
        oldY = y;
        g.drawImage(cash, 0, 0, null);
    }
}