package ssc;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.lang.*;

/**
 * <code>SwitchStarCraft</code> -  ,   SwitchStarCraft.
 */
public final class SwitchStarCraft extends JFrame {


    public java.util.Timer timer = new java.util.Timer();
    public java.util.TimerTask timerTask = new java.util.TimerTask() {
        public void run() {
            controller.processTimer();
        };
    };

    /**
     * ,    
     */
    public ssc.Controller controller = new Controller(new BattleField(), new ControlPanel(), new ClientArea(this));

    public void paintClient(Graphics g) {
        controller.processPaint(g);
    };

    private static SwitchStarCraft instance = null;
    public static SwitchStarCraft getInstance() {
        return instance;
    }


    /**
     * .       
     * @param s  
     */
    public SwitchStarCraft(String s) {
        super(s);
        instance = this;
        System.out.println("SwitchStarCraft started succesfully.");

        getContentPane().setLayout(new BorderLayout());
        getContentPane().add(controller.getClientArea());
        getContentPane().add(controller.getControlPanel(), BorderLayout.SOUTH);

        addComponentListener(new ComponentAdapter() {
            public void componentResized(ComponentEvent e) {
                if ((getSize().width == 700) && (getSize().height == 630))
                    return;
                setSize(700, 630);
            }
        });
        addKeyListener(controller);

        addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                System.exit(0);
            }
        });
        timer.schedule(timerTask, 100, 40);

        setSize(700, 630);
        setLocation(100, 100);//setBounds(100, 100, 400, 200);
        setVisible(true);
        repaint();
    }

    public static void main(String[] args) {
        Frame f;
        f = new SwitchStarCraft("SwitchStarCraft");
    };
}
